/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: ITestGenWizardPage.java,v 1.4 2005/02/16 22:20:27 qiyanli Exp $
 * 
 * Contributors: 
 * IBM Corporation - initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.internal.execution.testgen.ui.wizards;

import org.eclipse.jface.wizard.IWizardPage;

/**
 * interface to be extended by any object which wishes to provide a wizard page for a RunTestGenWizard
 * @author Ernest Jessee
 */
public interface ITestGenWizardPage extends IWizardPage
{
	/**
	 * called by RunTestGenWizard for the wizard page to save its settings in the preferance store	 *
	 */
	public void saveSettings();
	
	/**
	 * called to acquire the context sensitive help ID for this wizard page
	 */
	public String getContextHelpID();
}
