/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: FilterConfigType.java,v 1.2 2005/03/24 21:12:26 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.filter;

import org.eclipse.hyades.logging.adapter.model.internal.unit.ProcessUnitType;

/**
 * <!-- begin-user-doc -->
 * A representation of the model object '<em><b>Config Type</b></em>'.
 * <!-- end-user-doc -->
 *
 * <!-- begin-model-doc -->
 * This is the root element description. All the filter rules are hierarchically arranged under this element.
 * <!-- end-model-doc -->
 *
 * <p>
 * The following features are supported:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.filter.FilterConfigType#getAbstractFilterRule <em>Abstract Filter Rule</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.filter.FilterConfigType#getFilterRuleBlock <em>Filter Rule Block</em>}</li>
 * </ul>
 * </p>
 *
 * @see org.eclipse.hyades.logging.adapter.model.internal.filter.FilterPackage#getFilterConfigType()
 * @model 
 * @generated
 */
public interface FilterConfigType extends ProcessUnitType {
	/**
	 * Returns the value of the '<em><b>Abstract Filter Rule</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Abstract Filter Rule</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Abstract Filter Rule</em>' containment reference.
	 * @see #setAbstractFilterRule(AbstractFilterRuleType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.filter.FilterPackage#getFilterConfigType_AbstractFilterRule()
	 * @model containment="true" resolveProxies="false"
	 * @generated
	 */
	AbstractFilterRuleType getAbstractFilterRule();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.filter.FilterConfigType#getAbstractFilterRule <em>Abstract Filter Rule</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Abstract Filter Rule</em>' containment reference.
	 * @see #getAbstractFilterRule()
	 * @generated
	 */
	void setAbstractFilterRule(AbstractFilterRuleType value);

	/**
	 * Returns the value of the '<em><b>Filter Rule Block</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <p>
	 * If the meaning of the '<em>Filter Rule Block</em>' containment reference isn't clear,
	 * there really should be more of a description here...
	 * </p>
	 * <!-- end-user-doc -->
	 * @return the value of the '<em>Filter Rule Block</em>' containment reference.
	 * @see #setFilterRuleBlock(FilterRuleBlockType)
	 * @see org.eclipse.hyades.logging.adapter.model.internal.filter.FilterPackage#getFilterConfigType_FilterRuleBlock()
	 * @model containment="true" resolveProxies="false"
	 * @generated
	 */
	FilterRuleBlockType getFilterRuleBlock();

	/**
	 * Sets the value of the '{@link org.eclipse.hyades.logging.adapter.model.internal.filter.FilterConfigType#getFilterRuleBlock <em>Filter Rule Block</em>}' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param value the new value of the '<em>Filter Rule Block</em>' containment reference.
	 * @see #getFilterRuleBlock()
	 * @generated
	 */
	void setFilterRuleBlock(FilterRuleBlockType value);

} // FilterConfigType
