/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: ParserPackage.java,v 1.10 2005/03/24 21:12:27 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.parser;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * <!-- begin-model-doc -->
 * 
 *         Copyright (c) 2005 IBM Corporation and others.
 *         All rights reserved.   This program and the accompanying materials
 *         are made available under the terms of the Eclipse Public License v1.0
 *         which accompanies this distribution, and is available at
 *         http://www.eclipse.org/legal/epl-v10.html
 * 			
 * 		This document describes the format for representation of parser rules
 * 		which can be consumed by the generic parser component.
 * 		*********************************************************************
 * 		Change History:
 * 		31 Oct 2003 - Richard K Duggan initial implementation 
 * 		10 Nov 2003 - Richard K Duggan general fixes for id's
 * 		*********************************************************************
 * 		
 * 
 *           Copyright (c) 2005 IBM Corporation and others.
 *           All rights reserved.   This program and the accompanying materials
 *           are made available under the terms of the Eclipse Public License v1.0
 *           which accompanies this distribution, and is available at
 *           http://www.eclipse.org/legal/epl-v10.html
 *         
 * <!-- end-model-doc -->
 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserFactory
 * @generated
 */
public interface ParserPackage extends EPackage{
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "parser";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://www.eclipse.org/hyades/schema/Parser.xsd";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "parser";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	ParserPackage eINSTANCE = org.eclipse.hyades.logging.adapter.model.internal.parser.impl.ParserPackageImpl.init();

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.ParserConfigTypeImpl <em>Config Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.ParserConfigTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.ParserPackageImpl#getParserConfigType()
	 * @generated
	 */
	int PARSER_CONFIG_TYPE = 0;

	/**
	 * The feature id for the '<em><b>Rule Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARSER_CONFIG_TYPE__RULE_ELEMENT = 0;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARSER_CONFIG_TYPE__DESCRIPTION = 1;

	/**
	 * The feature id for the '<em><b>Designation Token</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARSER_CONFIG_TYPE__DESIGNATION_TOKEN = 2;

	/**
	 * The feature id for the '<em><b>Separator Token</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARSER_CONFIG_TYPE__SEPARATOR_TOKEN = 3;

	/**
	 * The feature id for the '<em><b>Unique ID</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARSER_CONFIG_TYPE__UNIQUE_ID = 4;

	/**
	 * The number of structural features of the the '<em>Config Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int PARSER_CONFIG_TYPE_FEATURE_COUNT = 5;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleAttributeTypeImpl <em>Rule Attribute Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleAttributeTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.ParserPackageImpl#getRuleAttributeType()
	 * @generated
	 */
	int RULE_ATTRIBUTE_TYPE = 1;

	/**
	 * The feature id for the '<em><b>Substitution Rule</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ATTRIBUTE_TYPE__SUBSTITUTION_RULE = 0;

	/**
	 * The feature id for the '<em><b>Default Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ATTRIBUTE_TYPE__DEFAULT_VALUE = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ATTRIBUTE_TYPE__ID = 2;

	/**
	 * The feature id for the '<em><b>Index</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ATTRIBUTE_TYPE__INDEX = 3;

	/**
	 * The feature id for the '<em><b>Is Required By Parent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ATTRIBUTE_TYPE__IS_REQUIRED_BY_PARENT = 4;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ATTRIBUTE_TYPE__NAME = 5;

	/**
	 * The feature id for the '<em><b>Use Previous Match Substitution As Default</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ATTRIBUTE_TYPE__USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT = 6;

	/**
	 * The number of structural features of the the '<em>Rule Attribute Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ATTRIBUTE_TYPE_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleElementTypeImpl <em>Rule Element Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleElementTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.ParserPackageImpl#getRuleElementType()
	 * @generated
	 */
	int RULE_ELEMENT_TYPE = 2;

	/**
	 * The feature id for the '<em><b>Rule Element</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ELEMENT_TYPE__RULE_ELEMENT = 0;

	/**
	 * The feature id for the '<em><b>Rule Attribute</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ELEMENT_TYPE__RULE_ATTRIBUTE = 1;

	/**
	 * The feature id for the '<em><b>Id</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ELEMENT_TYPE__ID = 2;

	/**
	 * The feature id for the '<em><b>Index</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ELEMENT_TYPE__INDEX = 3;

	/**
	 * The feature id for the '<em><b>Is Child Choice</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ELEMENT_TYPE__IS_CHILD_CHOICE = 4;

	/**
	 * The feature id for the '<em><b>Is Required By Parent</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ELEMENT_TYPE__IS_REQUIRED_BY_PARENT = 5;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ELEMENT_TYPE__NAME = 6;

	/**
	 * The number of structural features of the the '<em>Rule Element Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int RULE_ELEMENT_TYPE_FEATURE_COUNT = 7;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.SubstitutionRuleTypeImpl <em>Substitution Rule Type</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.SubstitutionRuleTypeImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.ParserPackageImpl#getSubstitutionRuleType()
	 * @generated
	 */
	int SUBSTITUTION_RULE_TYPE = 3;

	/**
	 * The feature id for the '<em><b>Match</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_RULE_TYPE__MATCH = 0;

	/**
	 * The feature id for the '<em><b>Positions</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_RULE_TYPE__POSITIONS = 1;

	/**
	 * The feature id for the '<em><b>Substitute</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_RULE_TYPE__SUBSTITUTE = 2;

	/**
	 * The feature id for the '<em><b>Substitution Extension Class</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_RULE_TYPE__SUBSTITUTION_EXTENSION_CLASS = 3;

	/**
	 * The feature id for the '<em><b>Time Format</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_RULE_TYPE__TIME_FORMAT = 4;

	/**
	 * The feature id for the '<em><b>Use Built In Function</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_RULE_TYPE__USE_BUILT_IN_FUNCTION = 5;

	/**
	 * The number of structural features of the the '<em>Substitution Rule Type</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int SUBSTITUTION_RULE_TYPE_FEATURE_COUNT = 6;

	/**
	 * The meta object id for the '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.DocumentRootImpl <em>Document Root</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.DocumentRootImpl
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.impl.ParserPackageImpl#getDocumentRoot()
	 * @generated
	 */
	int DOCUMENT_ROOT = 4;

	/**
	 * The feature id for the '<em><b>Mixed</b></em>' attribute list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__MIXED = 0;

	/**
	 * The feature id for the '<em><b>XMLNS Prefix Map</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XMLNS_PREFIX_MAP = 1;

	/**
	 * The feature id for the '<em><b>XSI Schema Location</b></em>' map.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__XSI_SCHEMA_LOCATION = 2;

	/**
	 * The feature id for the '<em><b>Rule Attribute</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__RULE_ATTRIBUTE = 3;

	/**
	 * The feature id for the '<em><b>Rule Element</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT__RULE_ELEMENT = 4;

	/**
	 * The number of structural features of the the '<em>Document Root</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int DOCUMENT_ROOT_FEATURE_COUNT = 5;


	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType <em>Config Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Config Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType
	 * @generated
	 */
	EClass getParserConfigType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getRuleElement <em>Rule Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Rule Element</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getRuleElement()
	 * @see #getParserConfigType()
	 * @generated
	 */
	EReference getParserConfigType_RuleElement();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getDescription <em>Description</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Description</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getDescription()
	 * @see #getParserConfigType()
	 * @generated
	 */
	EAttribute getParserConfigType_Description();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getDesignationToken <em>Designation Token</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Designation Token</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getDesignationToken()
	 * @see #getParserConfigType()
	 * @generated
	 */
	EAttribute getParserConfigType_DesignationToken();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getSeparatorToken <em>Separator Token</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Separator Token</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getSeparatorToken()
	 * @see #getParserConfigType()
	 * @generated
	 */
	EAttribute getParserConfigType_SeparatorToken();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getUniqueID <em>Unique ID</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Unique ID</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.ParserConfigType#getUniqueID()
	 * @see #getParserConfigType()
	 * @generated
	 */
	EAttribute getParserConfigType_UniqueID();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType <em>Rule Attribute Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rule Attribute Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType
	 * @generated
	 */
	EClass getRuleAttributeType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getSubstitutionRule <em>Substitution Rule</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Substitution Rule</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getSubstitutionRule()
	 * @see #getRuleAttributeType()
	 * @generated
	 */
	EReference getRuleAttributeType_SubstitutionRule();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getDefaultValue <em>Default Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Default Value</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getDefaultValue()
	 * @see #getRuleAttributeType()
	 * @generated
	 */
	EAttribute getRuleAttributeType_DefaultValue();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getId()
	 * @see #getRuleAttributeType()
	 * @generated
	 */
	EAttribute getRuleAttributeType_Id();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getIndex <em>Index</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Index</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getIndex()
	 * @see #getRuleAttributeType()
	 * @generated
	 */
	EAttribute getRuleAttributeType_Index();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#isIsRequiredByParent <em>Is Required By Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Required By Parent</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#isIsRequiredByParent()
	 * @see #getRuleAttributeType()
	 * @generated
	 */
	EAttribute getRuleAttributeType_IsRequiredByParent();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#getName()
	 * @see #getRuleAttributeType()
	 * @generated
	 */
	EAttribute getRuleAttributeType_Name();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#isUsePreviousMatchSubstitutionAsDefault <em>Use Previous Match Substitution As Default</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Use Previous Match Substitution As Default</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType#isUsePreviousMatchSubstitutionAsDefault()
	 * @see #getRuleAttributeType()
	 * @generated
	 */
	EAttribute getRuleAttributeType_UsePreviousMatchSubstitutionAsDefault();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType <em>Rule Element Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Rule Element Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType
	 * @generated
	 */
	EClass getRuleElementType();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getRuleElement <em>Rule Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Rule Element</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getRuleElement()
	 * @see #getRuleElementType()
	 * @generated
	 */
	EReference getRuleElementType_RuleElement();

	/**
	 * Returns the meta object for the containment reference list '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getRuleAttribute <em>Rule Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Rule Attribute</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getRuleAttribute()
	 * @see #getRuleElementType()
	 * @generated
	 */
	EReference getRuleElementType_RuleAttribute();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getId <em>Id</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Id</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getId()
	 * @see #getRuleElementType()
	 * @generated
	 */
	EAttribute getRuleElementType_Id();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getIndex <em>Index</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Index</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getIndex()
	 * @see #getRuleElementType()
	 * @generated
	 */
	EAttribute getRuleElementType_Index();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsChildChoice <em>Is Child Choice</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Child Choice</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsChildChoice()
	 * @see #getRuleElementType()
	 * @generated
	 */
	EAttribute getRuleElementType_IsChildChoice();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsRequiredByParent <em>Is Required By Parent</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Is Required By Parent</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#isIsRequiredByParent()
	 * @see #getRuleElementType()
	 * @generated
	 */
	EAttribute getRuleElementType_IsRequiredByParent();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType#getName()
	 * @see #getRuleElementType()
	 * @generated
	 */
	EAttribute getRuleElementType_Name();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType <em>Substitution Rule Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Substitution Rule Type</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType
	 * @generated
	 */
	EClass getSubstitutionRuleType();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getMatch <em>Match</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Match</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getMatch()
	 * @see #getSubstitutionRuleType()
	 * @generated
	 */
	EAttribute getSubstitutionRuleType_Match();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getPositions <em>Positions</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Positions</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getPositions()
	 * @see #getSubstitutionRuleType()
	 * @generated
	 */
	EAttribute getSubstitutionRuleType_Positions();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getSubstitute <em>Substitute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Substitute</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getSubstitute()
	 * @see #getSubstitutionRuleType()
	 * @generated
	 */
	EAttribute getSubstitutionRuleType_Substitute();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getSubstitutionExtensionClass <em>Substitution Extension Class</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Substitution Extension Class</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getSubstitutionExtensionClass()
	 * @see #getSubstitutionRuleType()
	 * @generated
	 */
	EAttribute getSubstitutionRuleType_SubstitutionExtensionClass();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getTimeFormat <em>Time Format</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Time Format</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#getTimeFormat()
	 * @see #getSubstitutionRuleType()
	 * @generated
	 */
	EAttribute getSubstitutionRuleType_TimeFormat();

	/**
	 * Returns the meta object for the attribute '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#isUseBuiltInFunction <em>Use Built In Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Use Built In Function</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType#isUseBuiltInFunction()
	 * @see #getSubstitutionRuleType()
	 * @generated
	 */
	EAttribute getSubstitutionRuleType_UseBuiltInFunction();

	/**
	 * Returns the meta object for class '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot <em>Document Root</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Document Root</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot
	 * @generated
	 */
	EClass getDocumentRoot();

	/**
	 * Returns the meta object for the attribute list '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getMixed <em>Mixed</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute list '<em>Mixed</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getMixed()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EAttribute getDocumentRoot_Mixed();

	/**
	 * Returns the meta object for the map '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getXMLNSPrefixMap <em>XMLNS Prefix Map</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XMLNS Prefix Map</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getXMLNSPrefixMap()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XMLNSPrefixMap();

	/**
	 * Returns the meta object for the map '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getXSISchemaLocation <em>XSI Schema Location</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the map '<em>XSI Schema Location</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getXSISchemaLocation()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_XSISchemaLocation();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getRuleAttribute <em>Rule Attribute</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Rule Attribute</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getRuleAttribute()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_RuleAttribute();

	/**
	 * Returns the meta object for the containment reference '{@link org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getRuleElement <em>Rule Element</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Rule Element</em>'.
	 * @see org.eclipse.hyades.logging.adapter.model.internal.parser.DocumentRoot#getRuleElement()
	 * @see #getDocumentRoot()
	 * @generated
	 */
	EReference getDocumentRoot_RuleElement();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	ParserFactory getParserFactory();

} //ParserPackage
