/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 *
 * Contributors:
 * IBM - Initial API and implementation
 *
 * $Id: RuleAttributeTypeImpl.java,v 1.11 2005/03/24 21:12:25 slavescu Exp $
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.model.internal.parser.impl;

import java.math.BigInteger;
import java.util.Collection;

import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.NotificationChain;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EStructuralFeature;
import org.eclipse.emf.ecore.InternalEObject;
import org.eclipse.emf.ecore.impl.ENotificationImpl;
import org.eclipse.emf.ecore.impl.EObjectImpl;
import org.eclipse.emf.ecore.util.EObjectContainmentEList;
import org.eclipse.emf.ecore.util.InternalEList;
import org.eclipse.hyades.logging.adapter.model.internal.parser.ParserPackage;
import org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType;
import org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType;
import org.eclipse.hyades.logging.adapter.model.internal.unit.util.Guid;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model object '<em><b>Rule Attribute Type</b></em>'.
 * <!-- end-user-doc -->
 * <p>
 * The following features are implemented:
 * <ul>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleAttributeTypeImpl#getSubstitutionRule <em>Substitution Rule</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleAttributeTypeImpl#getDefaultValue <em>Default Value</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleAttributeTypeImpl#getId <em>Id</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleAttributeTypeImpl#getIndex <em>Index</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleAttributeTypeImpl#isIsRequiredByParent <em>Is Required By Parent</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleAttributeTypeImpl#getName <em>Name</em>}</li>
 *   <li>{@link org.eclipse.hyades.logging.adapter.model.internal.parser.impl.RuleAttributeTypeImpl#isUsePreviousMatchSubstitutionAsDefault <em>Use Previous Match Substitution As Default</em>}</li>
 * </ul>
 * </p>
 *
 * @generated
 */
public class RuleAttributeTypeImpl extends EObjectImpl implements RuleAttributeType {
	/**
	 * The cached value of the '{@link #getSubstitutionRule() <em>Substitution Rule</em>}' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getSubstitutionRule()
	 * @generated
	 * @ordered
	 */
	protected EList substitutionRule = null;

	/**
	 * The default value of the '{@link #getDefaultValue() <em>Default Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefaultValue()
	 * @generated
	 * @ordered
	 */
	protected static final String DEFAULT_VALUE_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getDefaultValue() <em>Default Value</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getDefaultValue()
	 * @generated
	 * @ordered
	 */
	protected String defaultValue = DEFAULT_VALUE_EDEFAULT;

	/**
	 * The default value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected static final BigInteger ID_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getId() <em>Id</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getId()
	 * @generated
	 * @ordered
	 */
	protected BigInteger id = ID_EDEFAULT;

	/**
	 * The default value of the '{@link #getIndex() <em>Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndex()
	 * @generated
	 * @ordered
	 */
	protected static final String INDEX_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getIndex() <em>Index</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getIndex()
	 * @generated
	 * @ordered
	 */
	protected String index = INDEX_EDEFAULT;

	/**
	 * The default value of the '{@link #isIsRequiredByParent() <em>Is Required By Parent</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsRequiredByParent()
	 * @generated
	 * @ordered
	 */
	protected static final boolean IS_REQUIRED_BY_PARENT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isIsRequiredByParent() <em>Is Required By Parent</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isIsRequiredByParent()
	 * @generated
	 * @ordered
	 */
	protected boolean isRequiredByParent = IS_REQUIRED_BY_PARENT_EDEFAULT;

	/**
	 * This is true if the Is Required By Parent attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean isRequiredByParentESet = false;

	/**
	 * The default value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected static final String NAME_EDEFAULT = null;

	/**
	 * The cached value of the '{@link #getName() <em>Name</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #getName()
	 * @generated
	 * @ordered
	 */
	protected String name = NAME_EDEFAULT;

	/**
	 * The default value of the '{@link #isUsePreviousMatchSubstitutionAsDefault() <em>Use Previous Match Substitution As Default</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isUsePreviousMatchSubstitutionAsDefault()
	 * @generated
	 * @ordered
	 */
	protected static final boolean USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT_EDEFAULT = false;

	/**
	 * The cached value of the '{@link #isUsePreviousMatchSubstitutionAsDefault() <em>Use Previous Match Substitution As Default</em>}' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see #isUsePreviousMatchSubstitutionAsDefault()
	 * @generated
	 * @ordered
	 */
	protected boolean usePreviousMatchSubstitutionAsDefault = USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT_EDEFAULT;

	/**
	 * This is true if the Use Previous Match Substitution As Default attribute has been set.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	protected boolean usePreviousMatchSubstitutionAsDefaultESet = false;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated NOT
	 */
	protected RuleAttributeTypeImpl() {
		super();
		index = (new Guid()).toString();		
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected EClass eStaticClass() {
		return ParserPackage.eINSTANCE.getRuleAttributeType();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public EList getSubstitutionRule() {
		if (substitutionRule == null) {
			substitutionRule = new EObjectContainmentEList(SubstitutionRuleType.class, this, ParserPackage.RULE_ATTRIBUTE_TYPE__SUBSTITUTION_RULE);
		}
		return substitutionRule;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getDefaultValue() {
		return defaultValue;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setDefaultValue(String newDefaultValue) {
		String oldDefaultValue = defaultValue;
		defaultValue = newDefaultValue;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParserPackage.RULE_ATTRIBUTE_TYPE__DEFAULT_VALUE, oldDefaultValue, defaultValue));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public BigInteger getId() {
		return id;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setId(BigInteger newId) {
		BigInteger oldId = id;
		id = newId;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParserPackage.RULE_ATTRIBUTE_TYPE__ID, oldId, id));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getIndex() {
		return index;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIndex(String newIndex) {
		String oldIndex = index;
		index = newIndex;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParserPackage.RULE_ATTRIBUTE_TYPE__INDEX, oldIndex, index));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isIsRequiredByParent() {
		return isRequiredByParent;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setIsRequiredByParent(boolean newIsRequiredByParent) {
		boolean oldIsRequiredByParent = isRequiredByParent;
		isRequiredByParent = newIsRequiredByParent;
		boolean oldIsRequiredByParentESet = isRequiredByParentESet;
		isRequiredByParentESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParserPackage.RULE_ATTRIBUTE_TYPE__IS_REQUIRED_BY_PARENT, oldIsRequiredByParent, isRequiredByParent, !oldIsRequiredByParentESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetIsRequiredByParent() {
		boolean oldIsRequiredByParent = isRequiredByParent;
		boolean oldIsRequiredByParentESet = isRequiredByParentESet;
		isRequiredByParent = IS_REQUIRED_BY_PARENT_EDEFAULT;
		isRequiredByParentESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ParserPackage.RULE_ATTRIBUTE_TYPE__IS_REQUIRED_BY_PARENT, oldIsRequiredByParent, IS_REQUIRED_BY_PARENT_EDEFAULT, oldIsRequiredByParentESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetIsRequiredByParent() {
		return isRequiredByParentESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String getName() {
		return name;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setName(String newName) {
		String oldName = name;
		name = newName;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParserPackage.RULE_ATTRIBUTE_TYPE__NAME, oldName, name));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isUsePreviousMatchSubstitutionAsDefault() {
		return usePreviousMatchSubstitutionAsDefault;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setUsePreviousMatchSubstitutionAsDefault(boolean newUsePreviousMatchSubstitutionAsDefault) {
		boolean oldUsePreviousMatchSubstitutionAsDefault = usePreviousMatchSubstitutionAsDefault;
		usePreviousMatchSubstitutionAsDefault = newUsePreviousMatchSubstitutionAsDefault;
		boolean oldUsePreviousMatchSubstitutionAsDefaultESet = usePreviousMatchSubstitutionAsDefaultESet;
		usePreviousMatchSubstitutionAsDefaultESet = true;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.SET, ParserPackage.RULE_ATTRIBUTE_TYPE__USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT, oldUsePreviousMatchSubstitutionAsDefault, usePreviousMatchSubstitutionAsDefault, !oldUsePreviousMatchSubstitutionAsDefaultESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void unsetUsePreviousMatchSubstitutionAsDefault() {
		boolean oldUsePreviousMatchSubstitutionAsDefault = usePreviousMatchSubstitutionAsDefault;
		boolean oldUsePreviousMatchSubstitutionAsDefaultESet = usePreviousMatchSubstitutionAsDefaultESet;
		usePreviousMatchSubstitutionAsDefault = USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT_EDEFAULT;
		usePreviousMatchSubstitutionAsDefaultESet = false;
		if (eNotificationRequired())
			eNotify(new ENotificationImpl(this, Notification.UNSET, ParserPackage.RULE_ATTRIBUTE_TYPE__USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT, oldUsePreviousMatchSubstitutionAsDefault, USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT_EDEFAULT, oldUsePreviousMatchSubstitutionAsDefaultESet));
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean isSetUsePreviousMatchSubstitutionAsDefault() {
		return usePreviousMatchSubstitutionAsDefaultESet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NotificationChain eInverseRemove(InternalEObject otherEnd, int featureID, Class baseClass, NotificationChain msgs) {
		if (featureID >= 0) {
			switch (eDerivedStructuralFeatureID(featureID, baseClass)) {
				case ParserPackage.RULE_ATTRIBUTE_TYPE__SUBSTITUTION_RULE:
					return ((InternalEList)getSubstitutionRule()).basicRemove(otherEnd, msgs);
				default:
					return eDynamicInverseRemove(otherEnd, featureID, baseClass, msgs);
			}
		}
		return eBasicSetContainer(null, featureID, msgs);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Object eGet(EStructuralFeature eFeature, boolean resolve) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case ParserPackage.RULE_ATTRIBUTE_TYPE__SUBSTITUTION_RULE:
				return getSubstitutionRule();
			case ParserPackage.RULE_ATTRIBUTE_TYPE__DEFAULT_VALUE:
				return getDefaultValue();
			case ParserPackage.RULE_ATTRIBUTE_TYPE__ID:
				return getId();
			case ParserPackage.RULE_ATTRIBUTE_TYPE__INDEX:
				return getIndex();
			case ParserPackage.RULE_ATTRIBUTE_TYPE__IS_REQUIRED_BY_PARENT:
				return isIsRequiredByParent() ? Boolean.TRUE : Boolean.FALSE;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__NAME:
				return getName();
			case ParserPackage.RULE_ATTRIBUTE_TYPE__USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT:
				return isUsePreviousMatchSubstitutionAsDefault() ? Boolean.TRUE : Boolean.FALSE;
		}
		return eDynamicGet(eFeature, resolve);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eSet(EStructuralFeature eFeature, Object newValue) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case ParserPackage.RULE_ATTRIBUTE_TYPE__SUBSTITUTION_RULE:
				getSubstitutionRule().clear();
				getSubstitutionRule().addAll((Collection)newValue);
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__DEFAULT_VALUE:
				setDefaultValue((String)newValue);
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__ID:
				setId((BigInteger)newValue);
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__INDEX:
				setIndex((String)newValue);
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__IS_REQUIRED_BY_PARENT:
				setIsRequiredByParent(((Boolean)newValue).booleanValue());
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__NAME:
				setName((String)newValue);
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT:
				setUsePreviousMatchSubstitutionAsDefault(((Boolean)newValue).booleanValue());
				return;
		}
		eDynamicSet(eFeature, newValue);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void eUnset(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case ParserPackage.RULE_ATTRIBUTE_TYPE__SUBSTITUTION_RULE:
				getSubstitutionRule().clear();
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__DEFAULT_VALUE:
				setDefaultValue(DEFAULT_VALUE_EDEFAULT);
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__ID:
				setId(ID_EDEFAULT);
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__INDEX:
				setIndex(INDEX_EDEFAULT);
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__IS_REQUIRED_BY_PARENT:
				unsetIsRequiredByParent();
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__NAME:
				setName(NAME_EDEFAULT);
				return;
			case ParserPackage.RULE_ATTRIBUTE_TYPE__USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT:
				unsetUsePreviousMatchSubstitutionAsDefault();
				return;
		}
		eDynamicUnset(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public boolean eIsSet(EStructuralFeature eFeature) {
		switch (eDerivedStructuralFeatureID(eFeature)) {
			case ParserPackage.RULE_ATTRIBUTE_TYPE__SUBSTITUTION_RULE:
				return substitutionRule != null && !substitutionRule.isEmpty();
			case ParserPackage.RULE_ATTRIBUTE_TYPE__DEFAULT_VALUE:
				return DEFAULT_VALUE_EDEFAULT == null ? defaultValue != null : !DEFAULT_VALUE_EDEFAULT.equals(defaultValue);
			case ParserPackage.RULE_ATTRIBUTE_TYPE__ID:
				return ID_EDEFAULT == null ? id != null : !ID_EDEFAULT.equals(id);
			case ParserPackage.RULE_ATTRIBUTE_TYPE__INDEX:
				return INDEX_EDEFAULT == null ? index != null : !INDEX_EDEFAULT.equals(index);
			case ParserPackage.RULE_ATTRIBUTE_TYPE__IS_REQUIRED_BY_PARENT:
				return isSetIsRequiredByParent();
			case ParserPackage.RULE_ATTRIBUTE_TYPE__NAME:
				return NAME_EDEFAULT == null ? name != null : !NAME_EDEFAULT.equals(name);
			case ParserPackage.RULE_ATTRIBUTE_TYPE__USE_PREVIOUS_MATCH_SUBSTITUTION_AS_DEFAULT:
				return isSetUsePreviousMatchSubstitutionAsDefault();
		}
		return eDynamicIsSet(eFeature);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public String toString() {
		if (eIsProxy()) return super.toString();

		StringBuffer result = new StringBuffer(super.toString());
		result.append(" (defaultValue: ");
		result.append(defaultValue);
		result.append(", id: ");
		result.append(id);
		result.append(", index: ");
		result.append(index);
		result.append(", isRequiredByParent: ");
		if (isRequiredByParentESet) result.append(isRequiredByParent); else result.append("<unset>");
		result.append(", name: ");
		result.append(name);
		result.append(", usePreviousMatchSubstitutionAsDefault: ");
		if (usePreviousMatchSubstitutionAsDefaultESet) result.append(usePreviousMatchSubstitutionAsDefault); else result.append("<unset>");
		result.append(')');
		return result.toString();
	}

} //RuleAttributeTypeImpl
