/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: AcadEditorPlugin.java,v 1.16 2005/04/05 21:36:29 ewchan Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.logging.adapter.ui;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Iterator;
import java.util.Set;

import org.eclipse.core.resources.IResourceStatus;
import org.eclipse.core.resources.ResourcesPlugin;
import org.eclipse.core.runtime.IAdaptable;
import org.eclipse.core.runtime.IConfigurationElement;
import org.eclipse.core.runtime.IExtensionPoint;
import org.eclipse.core.runtime.IPath;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Path;
import org.eclipse.core.runtime.Platform;
import org.eclipse.core.runtime.Status;
import org.eclipse.emf.common.EMFPlugin;
import org.eclipse.emf.common.util.EList;
import org.eclipse.emf.common.util.ResourceLocator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import org.eclipse.hyades.logging.adapter.model.internal.parser.ParserFactory;
import org.eclipse.hyades.logging.adapter.model.internal.parser.RuleAttributeType;
import org.eclipse.hyades.logging.adapter.model.internal.parser.RuleElementType;
import org.eclipse.hyades.logging.adapter.model.internal.parser.SubstitutionRuleType;
import org.eclipse.hyades.logging.adapter.ui.internal.util.AcadPerspective;
import org.eclipse.hyades.logging.adapter.ui.preferences.AcadEditorPreferencePage;
import org.eclipse.jface.dialogs.ErrorDialog;
import org.eclipse.jface.dialogs.IDialogConstants;
import org.eclipse.jface.dialogs.MessageDialogWithToggle;
import org.eclipse.swt.custom.BusyIndicator;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.ui.IPerspectiveDescriptor;
import org.eclipse.ui.IPerspectiveRegistry;
import org.eclipse.ui.IPluginContribution;
import org.eclipse.ui.IWorkbench;
import org.eclipse.ui.IWorkbenchPage;
import org.eclipse.ui.IWorkbenchWindow;
import org.eclipse.ui.PlatformUI;
import org.eclipse.ui.activities.IActivityManager;
import org.eclipse.ui.activities.IIdentifier;
import org.eclipse.ui.activities.IWorkbenchActivitySupport;
import org.eclipse.ui.activities.WorkbenchActivityHelper;
import org.eclipse.xsd.XSDAttributeUse;
import org.eclipse.xsd.XSDComplexTypeContent;
import org.eclipse.xsd.XSDComplexTypeDefinition;
import org.eclipse.xsd.XSDElementDeclaration;
import org.eclipse.xsd.XSDModelGroup;
import org.eclipse.xsd.XSDParticle;
import org.eclipse.xsd.XSDParticleContent;
import org.eclipse.xsd.XSDSchema;
import org.eclipse.xsd.XSDTerm;
import org.eclipse.xsd.XSDTypeDefinition;
import org.eclipse.xsd.XSDWildcard;
import org.eclipse.xsd.util.XSDResourceImpl;
import org.osgi.framework.Bundle;
import org.osgi.framework.BundleContext;

/**
 * This is the central singleton for the Adapter editor plugin.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public final class AcadEditorPlugin extends EMFPlugin {
	
	private static final String extensionPointID = "cbeSchema";
	public static final String cbeName = "CommonBaseEvent";
	protected String identifier;
	
	/**
	 * Keep track of the singleton.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final AcadEditorPlugin INSTANCE = new AcadEditorPlugin();

	/**
	 * Keep track of the singleton.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	private static Implementation plugin;
	
	private HashMap elementMap;
	private HashMap inheritedTypesMap;
	private XSDSchema schema;
	

	/**
	 * Create the instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AcadEditorPlugin() {
		super
		  (new ResourceLocator [] {
		   });
	}

	/**
	 * Returns the singleton instance of the Eclipse plugin.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the singleton instance.
	 * @generated
	 */
	public ResourceLocator getPluginResourceLocator() {
		return plugin;
	}

	/**
	 * Returns the singleton instance of the Eclipse plugin.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the singleton instance.
	 * @generated
	 */
	public static Implementation getPlugin() {
		return plugin;
	}

	/**
	 * The actual implementation of the Eclipse <b>Plugin</b>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static class Implementation extends EclipsePlugin {
		/**
		 * Creates an instance.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @param descriptor the description of the plugin.
		 * @generated
		 */
		public Implementation() {
			// Remember the static instance.
			//
			plugin = this;
		}
		
	    /**
	     * @see org.osgi.framework.BundleActivator#start(org.osgi.framework.BundleContext)
	     */
	    public void start(BundleContext context) throws Exception {
	       
	        super.start(context);
			getPlugin().getPluginPreferences().setDefault(AcadEditorPreferencePage.BUFFER_SIZE, AcadEditorPreferencePage.DEFAULT_SIZE);
			getPlugin().getPluginPreferences().setDefault(AcadEditorPreferencePage.SWITCH_TO_PERSPECTIVE_KEY, MessageDialogWithToggle.PROMPT);			
	    }		
	}
	
	public HashMap getCBEElements()
	{
		if(elementMap == null)
		{
			BusyIndicator.showWhile(Display.getCurrent(), new Runnable() {
				public void run() {
					loadCBEPackageInfo();
				}
			});
			
		}
		   		   		   
		return elementMap;    
	}
	
	public void loadCBEPackageInfo()
	{
		XSDSchema schema = getCBESchema();
		
		elementMap = new HashMap();
		inheritedTypesMap = new HashMap();
        
        if(schema == null)
        {    
			String msg = getPlugin().getString("STR_SCHEMA_ERROR");
			Status err =
				new Status(
					Status.WARNING,
					ResourcesPlugin.PI_RESOURCES,
					IResourceStatus.INTERNAL_ERROR,
					msg,
					null);

			ErrorDialog.openError(Display.getCurrent().getActiveShell(), AcadEditorPlugin.getPlugin().getString("STR_AD_MSG_TITLE"), "", err);

        	return;
        }
          
		EList elems = schema.getElementDeclarations();
		for(int idx=0; idx<elems.size(); idx++)
		{
			XSDElementDeclaration elem = (XSDElementDeclaration)elems.get(idx);
			elementMap.put(elem.getName(), elem);
		}
		
		elems = schema.getTypeDefinitions();
		for(int idx=0; idx<elems.size(); idx++)
		{
			XSDTypeDefinition elem = (XSDTypeDefinition)elems.get(idx);
			
			Object value = inheritedTypesMap.get(elem);
			if(value == null)
				inheritedTypesMap.put(elem, new ArrayList());
				
			XSDTypeDefinition baseType = elem.getBaseType();
			if(baseType != null)
			{
				value = inheritedTypesMap.get(baseType);
				if(value == null)
				{
					ArrayList list = new ArrayList();
					list.add(elem);
					
					inheritedTypesMap.put(baseType, list);
				}
				else
				{
					((ArrayList)value).add(elem);
				}
			}
		}
		
	 }

	protected XSDSchema getCBESchema()
	{
		if(schema != null)
		  return schema;
    	
		//IExtensionPoint point = getPlugin().getDescriptor().getExtensionPoint(extensionPointID);
		IExtensionPoint point = Platform.getExtensionRegistry().getExtensionPoint(getPluginId(), extensionPointID);		

		if (point != null) {
			IConfigurationElement[] elements = point.getConfigurationElements();

			for (int i = 0; i < elements.length; i++) {
				
				IConfigurationElement elem = elements[i];
				
				String schemaName = elem.getAttribute("name");
				if(schemaName == null || schemaName.length() == 0)
				  return null;

				URI uri = null;

				IPath path = new Path(schemaName);
				if(path.segmentCount() > 1)
				{//first string should be a plugin id
					String pluginId = path.segment(0);
					String fileName  = schemaName.substring(pluginId.length());
					
					Bundle bundle = Platform.getBundle(pluginId);
					if(bundle != null)
					{
						uri = URI.createURI(new StringBuffer(bundle.getEntry("/").toString()).append(fileName).toString());
						
					}
				}
				else
				{
					uri = URI.createURI(schemaName);	
				}
				
				ResourceSet resourceSet = new ResourceSetImpl();
				XSDResourceImpl xsdSchemaResource = (XSDResourceImpl)resourceSet.getResource(
						uri, true);

				for (Iterator resources = resourceSet.getResources().iterator(); 
					resources.hasNext(); /* no-op */)
				{
					// Return the first schema object found, which is the main schema 
					//   loaded from the provided schemaURL
					Resource resource = (Resource)resources.next();
					if (resource instanceof XSDResourceImpl)
					{
						XSDResourceImpl xsdResource = (XSDResourceImpl)resource;
						
						schema = xsdResource.getSchema();
						// This returns a org.eclipse.xsd.XSDSchema object
						return schema;
					}
				}

				
			}
		}
    	
		return null;
	}

	public Object getElementDefinitionForType(RuleElementType elem)
	{
		String elementName = elem.getName();
		if(elementName == null)
		  return null;
    	  
		Object cbeObject = AcadEditorPlugin.INSTANCE.getCBEElements().get(elementName);
		if(cbeObject != null)
		{
			return cbeObject;
		}
		else// CBE reference
		{
			EObject container = elem.eContainer();
			ArrayList list = new ArrayList();
			
			while(container != null && container instanceof RuleElementType && cbeObject == null)
			{
				cbeObject = AcadEditorPlugin.INSTANCE.getCBEElements().get(((RuleElementType)container).getName());			
				
				if(cbeObject == null)
				{
					String name = ((RuleElementType)container).getName();				
					list.add(name);					
				}
				container = ((RuleElementType)container).eContainer();	
							
			}
			
			if(cbeObject == null)
			  return null;
			  
			for(int idx=list.size()-1; idx>=0; idx--)
			{
				cbeObject = AcadEditorPlugin.INSTANCE.getElementDefinitionFromType(((XSDElementDeclaration)cbeObject).getType(), list.get(idx).toString());
				if(cbeObject == null)
				   break;
			}
			
			if(cbeObject != null && cbeObject instanceof XSDElementDeclaration)
				return getElementDefinitionFromType(((XSDElementDeclaration)cbeObject).getTypeDefinition(), elementName);
			else if(cbeObject instanceof XSDTypeDefinition)	
				return getElementDefinitionFromType((XSDTypeDefinition)cbeObject, elementName);
			
		   return null;	
			
					
		}
	}
    
    
		public Object getElementDefinitionFromType(XSDTypeDefinition type, String typeName)
		{
			if(type == null || typeName == null)
			  return null;
			
	//		XSDTypeDefinition type = cbeObject.getTypeDefinition();
			
			if(type instanceof XSDComplexTypeDefinition)
			{
				XSDComplexTypeDefinition ctype = (XSDComplexTypeDefinition)type;			
				
				if(ctype.isAbstract())
				{//get inherited classes
					
					Object inhList = getInheritedTypes(ctype);
					if(inhList != null)
					{
						ArrayList list = (ArrayList)inhList;
						for(int idx=0; idx<list.size(); idx++)
						{
							XSDTypeDefinition def = (XSDTypeDefinition)list.get(idx);
							if(def.getName().equals(typeName))
							{
								return def;
							}
						}
					}
				}
	
				XSDComplexTypeContent tdef = ctype.getContentType();			
				if(tdef != null && tdef instanceof XSDParticle)
				{
					XSDParticleContent pcontent = ((XSDParticle)tdef).getContent();
					if(pcontent instanceof XSDModelGroup)
					{
						XSDModelGroup group = (XSDModelGroup)pcontent;
						EList tcontents = group.getContents();
					
						for(int i=0; i<tcontents.size(); i++)
						{
							XSDParticle obj = (XSDParticle)tcontents.get(i);						
							XSDTerm odecl = obj.getTerm();
							if(odecl instanceof XSDElementDeclaration)
							{
								XSDElementDeclaration edecl = (XSDElementDeclaration)odecl;
								if (edecl.getType() instanceof XSDComplexTypeDefinition){
									if (((XSDComplexTypeDefinition) edecl.getType()).isAbstract()){
										Object inhList = getInheritedTypes(edecl.getType());
										if(inhList != null)
										{
											ArrayList list = (ArrayList)inhList;
											for(int idx=0; idx<list.size(); idx++)
											{
												XSDTypeDefinition def = (XSDTypeDefinition)list.get(idx);
												if(def.getName().equals(typeName))
												{
													return def;
												}
											}
										}
									}
								}
								if(edecl.getName().equals(typeName))
								  return edecl;
								
							}
							else if(odecl instanceof XSDModelGroup) //array attributes
							{
								EList elemList = ((XSDModelGroup)odecl).getContents();
								
								for(int k=0; k<elemList.size(); k++)
								{
									XSDTerm term = ((XSDParticle)elemList.get(k)).getTerm();
									if(term instanceof XSDElementDeclaration)
									{
										XSDElementDeclaration edecl = (XSDElementDeclaration)term;
										if(edecl.getName().equals(typeName))
										  return edecl;
								
									}
								}														
							}
							else if(odecl instanceof XSDWildcard)
							{
								XSDWildcard wcard = (XSDWildcard)odecl;
								if(wcard.getStringLexicalNamespaceConstraint().equals(typeName))
								  return wcard;
	
							}
							
						}
						
					}
					
				}	
			}		
			return null;
		}
	
	public Object getInheritedTypes(XSDTypeDefinition type)
	{
		if(inheritedTypesMap == null)
		  return null;
		  
		return inheritedTypesMap.get(type);  
	}
	
	public Object getTypeFromName(String name)
	{
		if(inheritedTypesMap == null)
		  return null;
		  
		Iterator iterator = inheritedTypesMap.keySet().iterator();
		while(iterator.hasNext())
		{
			XSDTypeDefinition type = (XSDTypeDefinition)iterator.next();
			if(type.getName().equals(name))
			   return type;
		}
		  
		return null;  
	}

	public static AcadEditorPlugin getDefault() {
		return INSTANCE;
	}

	public void logMessage(IStatus status, boolean showMessageDialog)
	{
		plugin.getLog().log(status);
    	
		if(showMessageDialog)
		{
			ErrorDialog.openError(getActiveWorkbenchWindow().getShell()
			   , "Generic Adaptor Message"
			   , null
			   , status
			   , IStatus.ERROR);    		
		}
    	
	}
    
	public void logMessage(IStatus status)
	{
		logMessage(status, false);
    	
	}
	
	public void log(Object logEntry)
	{
		if (logEntry instanceof Throwable)
		{
			Throwable err = (Throwable)logEntry;
			Status multiStatus = new Status(IStatus.ERROR, getPluginId(), 0
			      , err.getLocalizedMessage(), null);
			      			      
			logMessage(multiStatus, true);      
		}
		else
		{
			Status status = new Status(IStatus.ERROR, getPluginId(), 0
				  , logEntry.toString(), null);
				  
		    logMessage(status, true);		  
		}
		
	}

	public IWorkbenchWindow getActiveWorkbenchWindow() {
		return PlatformUI.getWorkbench().getActiveWorkbenchWindow();
	}
	
	/**
	 * 
	 * @return
	 */
	public IWorkbenchPage getActivePage() {
		IWorkbenchWindow window=getActiveWorkbenchWindow();
		if(window==null) {
			return null;
		}
		IWorkbenchPage page = getActiveWorkbenchWindow().getActivePage();

		if (page == null
			|| !page.getPerspective().getId().equals(
				AcadPerspective.ID_ACAD_PERSPECTIVE)) {
			final IWorkbenchWindow dwindow = getActiveWorkbenchWindow();
			page = null;

			try {

				IWorkbenchPage[] persps = dwindow.getPages();
				for (int idx = 0; idx < persps.length; idx++) {
					if (persps[idx]
						.getPerspective()
						.getId()
						.equals(AcadPerspective.ID_ACAD_PERSPECTIVE)) {
						page = persps[idx];

						dwindow.setActivePage(page);
						break;
					}
				}

				if (page == null) {
					IAdaptable element = ResourcesPlugin.getWorkspace().getRoot();
					IWorkbench workBench = dwindow.getWorkbench();
					if (workBench != null && element != null)
						page =
							workBench.showPerspective(
								AcadPerspective.ID_ACAD_PERSPECTIVE,
								getActiveWorkbenchWindow(),
								element);
				}
			} catch (Exception exc) {
//				AcadEditorPlugin.INSTANCE.log(exc);			
			}
		}

		return page;
	}

	public String getPluginId()
	{
		if(identifier == null)
		   identifier = plugin.getBundle().getSymbolicName();

		return identifier;
	}

	public void createRequiredAttributes(RuleElementType element, XSDTypeDefinition type)
	{
		if(type instanceof XSDComplexTypeDefinition)
		{
			XSDComplexTypeDefinition complexType = (XSDComplexTypeDefinition)type;
			
			EList attrs = complexType.getAttributeUses();
			for(int idx=0; idx<attrs.size(); idx++)
			{
				XSDAttributeUse attr = (XSDAttributeUse) attrs.get(idx);
				
				if(!attr.isRequired())
				  continue;
				  
				if(complexType.getName()!=null && complexType.getName().equals("Situation") && attr.getAttributeDeclaration().getName().equals("categoryName"))
					continue;
				
				RuleAttributeType ruleAtribute = ParserFactory.eINSTANCE.createRuleAttributeType();
				ruleAtribute.setUsePreviousMatchSubstitutionAsDefault(true);
				ruleAtribute.setUsePreviousMatchSubstitutionAsDefault(false);
				ruleAtribute.setName(attr.getAttributeDeclaration().getName());
				ruleAtribute.setIsRequiredByParent(false);
				
				element.getRuleAttribute().add(ruleAtribute);
				
				//add substitution rule
				SubstitutionRuleType subs = ParserFactory.eINSTANCE.createSubstitutionRuleType();
				subs.setMatch("^(.*)");
				subs.setSubstitute("replace with our message text");
				subs.setUseBuiltInFunction(true);
				subs.setUseBuiltInFunction(false);
				ruleAtribute.getSubstitutionRule().add(subs);
				
			}
		}		
	}
	
	/**
	 * Asks the user whether they want to switch to the given
	 * perspective. Returns the user's response. If we are already
	 * in the given perspective, returns false. Must be called from
	 * the UI thread.
	 */
	public boolean openPerspectiveSwitchDialog(Shell shell, String preferenceKey, String message) {
		if (isCurrentPerspective(PlatformUI.getWorkbench().getActiveWorkbenchWindow(), AcadPerspective.ID_ACAD_PERSPECTIVE)) {
			return false;
		}
		String perspectiveName= getPerspectiveLabel(AcadPerspective.ID_ACAD_PERSPECTIVE);
		if (perspectiveName == null) {
			return false;
		}
		String preferenceValue = getPlugin().getPluginPreferences().getString(preferenceKey);
		if (preferenceValue == null || preferenceValue.length() == 0) {
			preferenceValue = MessageDialogWithToggle.PROMPT;
			getPlugin().getPluginPreferences().setValue(preferenceKey, preferenceValue);
		}
		boolean changePerspective = false;
		if (MessageDialogWithToggle.PROMPT.equals(preferenceValue)) {
			MessageDialogWithToggle dialog = MessageDialogWithToggle.openYesNoQuestion(shell, 
									getString("CONFIRM_PERSP_SWITCH"), 
									MessageFormat.format(message, new String[] { perspectiveName }),
									null, false, null, null); //$NON-NLS-1$
			changePerspective = (dialog.getReturnCode()== IDialogConstants.YES_ID);
			
			if (dialog.getToggleState())
			{
				if (changePerspective)
					getPlugin().getPluginPreferences().setValue(preferenceKey, MessageDialogWithToggle.ALWAYS);
				else
					getPlugin().getPluginPreferences().setValue(preferenceKey, MessageDialogWithToggle.NEVER);
				
				getPlugin().savePluginPreferences();
			}
		}

		if (!getContributions(AcadPerspective.ID_ACAD_PERSPECTIVE)){
			return false;
		}
		preferenceValue = getPlugin().getPluginPreferences().getString(preferenceKey);
		if (MessageDialogWithToggle.ALWAYS.equals(preferenceValue)) {
			return true;
		}
		else if (!changePerspective || MessageDialogWithToggle.NEVER.equals(preferenceValue)){
			return false;
		}
		return true;
	}
	
	/**
	 * Returns whether the given perspective identifier matches the
	 * identifier of the current perspective.
	 * 
	 * @param perspectiveId the identifier
	 * @return whether the given perspective identifier matches the
	 *  identifier of the current perspective
	 */
	private boolean isCurrentPerspective(IWorkbenchWindow window, String perspectiveId) {
		boolean isCurrent= false;
		if (window != null) {
			IWorkbenchPage page = window.getActivePage();
			if (page != null) {
				IPerspectiveDescriptor perspectiveDescriptor = page.getPerspective();
				if (perspectiveDescriptor != null) {
					isCurrent= perspectiveId.equals(perspectiveDescriptor.getId());
				}
			}
		}
		return isCurrent;
	}	
	
	/**
	 * Returns the label of the perspective with the given identifier or
	 * <code>null</code> if no such perspective exists.
	 * 
	 * @param perspectiveId the identifier
	 * @return the label of the perspective with the given identifier or
	 *  <code>null</code> if no such perspective exists 
	 */
	private String getPerspectiveLabel(String perspectiveId) {
		IPerspectiveDescriptor newPerspective = PlatformUI.getWorkbench().getPerspectiveRegistry().findPerspectiveWithId(perspectiveId);
		if (newPerspective == null) {
			return null;
		}
		return newPerspective.getLabel();
	}	
	
	/**
	 * Check if required activities are enabled.
	 */
	private boolean getContributions(String perspectiveId){
		// Map perspective id to descriptor.
        IPerspectiveRegistry reg = PlatformUI.getWorkbench().getPerspectiveRegistry();

        // leave this code in - the perspective of a given project may map to
        // activities other than those that the wizard itself maps to.
        IPerspectiveDescriptor finalPersp = reg.findPerspectiveWithId(perspectiveId);
        if (finalPersp != null && finalPersp instanceof IPluginContribution) {
            IPluginContribution contribution = (IPluginContribution) finalPersp;
            
            if (contribution.getPluginId() != null) {
                IWorkbenchActivitySupport workbenchActivitySupport = PlatformUI.getWorkbench().getActivitySupport();
                IActivityManager activityManager = workbenchActivitySupport.getActivityManager();
                IIdentifier identifier = activityManager.getIdentifier(WorkbenchActivityHelper.createUnifiedId(contribution));
                Set idActivities = identifier.getActivityIds();

                if (!idActivities.isEmpty()) {
                    Set enabledIds = new HashSet(activityManager.getEnabledActivityIds());

                    if (enabledIds.addAll(idActivities))
                        workbenchActivitySupport.setEnabledActivityIds(enabledIds);
                }
            }
        } else {
			Status status = new Status(IStatus.WARNING, getPluginId(), 0
				      ,"Unable to find perspective " + perspectiveId , null); //$NON-NLS-1$
            logMessage(status);
            
            return false;
        }
        return true;
	}	
}
