/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: Common_ConfigurationAdapterFactory.java,v 1.15 2005/03/28 21:51:32 jptoomey Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
 
/*
 * generated using Hyades customized JET templates
 */

package org.eclipse.hyades.models.common.configuration.util;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notifier;
import org.eclipse.emf.common.notify.impl.AdapterFactoryImpl;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.hyades.models.common.common.CMNNamedElement;
import org.eclipse.hyades.models.common.common.CMNNodeInstance;
import org.eclipse.hyades.models.common.common.CMNNodeType;
import org.eclipse.hyades.models.common.configuration.*;

import org.eclipse.hyades.models.common.configuration.CFGArtifact;
import org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair;
import org.eclipse.hyades.models.common.configuration.CFGCategory;
import org.eclipse.hyades.models.common.configuration.CFGClass;
import org.eclipse.hyades.models.common.configuration.CFGComparableProperty;
import org.eclipse.hyades.models.common.configuration.CFGConfigurableObject;
import org.eclipse.hyades.models.common.configuration.CFGInstance;
import org.eclipse.hyades.models.common.configuration.CFGLocation;
import org.eclipse.hyades.models.common.configuration.CFGMachine;
import org.eclipse.hyades.models.common.configuration.CFGMachineConstraint;
import org.eclipse.hyades.models.common.configuration.CFGMachineInstance;
import org.eclipse.hyades.models.common.configuration.CFGOperation;
import org.eclipse.hyades.models.common.configuration.CFGPropertyGroup;
import org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration;
import org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage;
import org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesBrowserTypeCategory;
import org.eclipse.hyades.models.common.configuration.HyadesBrowserVersionCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDatabaseCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesDatabaseVersionCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayNumberCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthCategory;
import org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesHostnameCategory;
import org.eclipse.hyades.models.common.configuration.HyadesMajorVersionCategory;
import org.eclipse.hyades.models.common.configuration.HyadesMemorySizeCategory;
import org.eclipse.hyades.models.common.configuration.HyadesMinorVersionCategory;
import org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemCategory;
import org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesPasswordCategory;
import org.eclipse.hyades.models.common.configuration.HyadesProcessorNumberCategory;
import org.eclipse.hyades.models.common.configuration.HyadesProcessorSpeedCategory;
import org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeCategory;
import org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesServicePackCategory;
import org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration;
import org.eclipse.hyades.models.common.configuration.HyadesUsernameCategory;
import org.eclipse.hyades.models.common.configuration.HyadesWindowsDomainCategory;
import org.eclipse.hyades.models.common.interactions.BVRProperty;

/**
 * <!-- begin-user-doc -->
 * The <b>Adapter Factory</b> for the model.
 * It provides an adapter <code>createXXX</code> method for each class of the model.
 * <!-- end-user-doc -->
 * @see org.eclipse.hyades.models.common.configuration.Common_ConfigurationPackage
 * @generated
 */
public class Common_ConfigurationAdapterFactory extends AdapterFactoryImpl
{
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static final String copyright = "";

	/**
	 * The cached model package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected static Common_ConfigurationPackage modelPackage;

	/**
	 * Creates an instance of the adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Common_ConfigurationAdapterFactory() {
		if (modelPackage == null) {
			modelPackage = Common_ConfigurationPackage.eINSTANCE;
		}
	}

	/**
	 * Returns whether this factory is applicable for the type of the object.
	 * <!-- begin-user-doc -->
	 * This implementation returns <code>true</code> if the object is either the model's package or is an instance object of the model.
	 * <!-- end-user-doc -->
	 * @return whether this factory is applicable for the type of the object.
	 * @generated
	 */
	public boolean isFactoryForType(Object object) {
		if (object == modelPackage) {
			return true;
		}
		if (object instanceof EObject) {
			return ((EObject)object).eClass().getEPackage() == modelPackage;
		}
		return false;
	}

	/**
	 * The switch the delegates to the <code>createXXX</code> methods.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Common_ConfigurationSwitch modelSwitch =
		new Common_ConfigurationSwitch() {
			public Object caseCFGLocation(CFGLocation object) {
				return createCFGLocationAdapter();
			}
			public Object caseCFGClass(CFGClass object) {
				return createCFGClassAdapter();
			}
			public Object caseCFGOperation(CFGOperation object) {
				return createCFGOperationAdapter();
			}
			public Object caseCFGArtifact(CFGArtifact object) {
				return createCFGArtifactAdapter();
			}
			public Object caseCFGInstance(CFGInstance object) {
				return createCFGInstanceAdapter();
			}
			public Object caseCFGComparableProperty(CFGComparableProperty object) {
				return createCFGComparablePropertyAdapter();
			}
			public Object caseCFGPropertyGroup(CFGPropertyGroup object) {
				return createCFGPropertyGroupAdapter();
			}
			public Object caseCFGCategory(CFGCategory object) {
				return createCFGCategoryAdapter();
			}
			public Object caseHyadesOperatingSystemEnumeration(HyadesOperatingSystemEnumeration object) {
				return createHyadesOperatingSystemEnumerationAdapter();
			}
			public Object caseHyadesOperatingSystemCategory(HyadesOperatingSystemCategory object) {
				return createHyadesOperatingSystemCategoryAdapter();
			}
			public Object caseHyadesProcessorTypeCategory(HyadesProcessorTypeCategory object) {
				return createHyadesProcessorTypeCategoryAdapter();
			}
			public Object caseHyadesMemorySizeCategory(HyadesMemorySizeCategory object) {
				return createHyadesMemorySizeCategoryAdapter();
			}
			public Object caseHyadesProcessorSpeedCategory(HyadesProcessorSpeedCategory object) {
				return createHyadesProcessorSpeedCategoryAdapter();
			}
			public Object caseHyadesProcessorTypeEnumeration(HyadesProcessorTypeEnumeration object) {
				return createHyadesProcessorTypeEnumerationAdapter();
			}
			public Object caseHyadesBrowserTypeCategory(HyadesBrowserTypeCategory object) {
				return createHyadesBrowserTypeCategoryAdapter();
			}
			public Object caseHyadesBrowserVersionCategory(HyadesBrowserVersionCategory object) {
				return createHyadesBrowserVersionCategoryAdapter();
			}
			public Object caseHyadesBrowserEnumeration(HyadesBrowserEnumeration object) {
				return createHyadesBrowserEnumerationAdapter();
			}
			public Object caseHyadesProcessorNumberCategory(HyadesProcessorNumberCategory object) {
				return createHyadesProcessorNumberCategoryAdapter();
			}
			public Object caseHyadesDisplayColorDepthCategory(HyadesDisplayColorDepthCategory object) {
				return createHyadesDisplayColorDepthCategoryAdapter();
			}
			public Object caseHyadesDisplayColorDepthEnumeration(HyadesDisplayColorDepthEnumeration object) {
				return createHyadesDisplayColorDepthEnumerationAdapter();
			}
			public Object caseHyadesDisplayHeightCategory(HyadesDisplayHeightCategory object) {
				return createHyadesDisplayHeightCategoryAdapter();
			}
			public Object caseHyadesDisplayWidthCategory(HyadesDisplayWidthCategory object) {
				return createHyadesDisplayWidthCategoryAdapter();
			}
			public Object caseHyadesDisplayHeightEnumeration(HyadesDisplayHeightEnumeration object) {
				return createHyadesDisplayHeightEnumerationAdapter();
			}
			public Object caseHyadesDisplayWidthEnumeration(HyadesDisplayWidthEnumeration object) {
				return createHyadesDisplayWidthEnumerationAdapter();
			}
			public Object caseHyadesDisplayNumberCategory(HyadesDisplayNumberCategory object) {
				return createHyadesDisplayNumberCategoryAdapter();
			}
			public Object caseHyadesDatabaseCategory(HyadesDatabaseCategory object) {
				return createHyadesDatabaseCategoryAdapter();
			}
			public Object caseHyadesDatabaseVersionCategory(HyadesDatabaseVersionCategory object) {
				return createHyadesDatabaseVersionCategoryAdapter();
			}
			public Object caseHyadesDatabaseEnumeration(HyadesDatabaseEnumeration object) {
				return createHyadesDatabaseEnumerationAdapter();
			}
			public Object caseCFGMachineInstance(CFGMachineInstance object) {
				return createCFGMachineInstanceAdapter();
			}
			public Object caseCFGMachineConstraint(CFGMachineConstraint object) {
				return createCFGMachineConstraintAdapter();
			}
			public Object caseCFGConfigurableObject(CFGConfigurableObject object) {
				return createCFGConfigurableObjectAdapter();
			}
			public Object caseHyadesHostnameCategory(HyadesHostnameCategory object) {
				return createHyadesHostnameCategoryAdapter();
			}
			public Object caseHyadesWindowsDomainCategory(HyadesWindowsDomainCategory object) {
				return createHyadesWindowsDomainCategoryAdapter();
			}
			public Object caseHyadesUsernameCategory(HyadesUsernameCategory object) {
				return createHyadesUsernameCategoryAdapter();
			}
			public Object caseHyadesServicePackCategory(HyadesServicePackCategory object) {
				return createHyadesServicePackCategoryAdapter();
			}
			public Object caseHyadesMajorVersionCategory(HyadesMajorVersionCategory object) {
				return createHyadesMajorVersionCategoryAdapter();
			}
			public Object caseHyadesMinorVersionCategory(HyadesMinorVersionCategory object) {
				return createHyadesMinorVersionCategoryAdapter();
			}
			public Object caseHyadesServicePackEnumeration(HyadesServicePackEnumeration object) {
				return createHyadesServicePackEnumerationAdapter();
			}
			public Object caseCFGArtifactLocationPair(CFGArtifactLocationPair object) {
				return createCFGArtifactLocationPairAdapter();
			}
			public Object caseCFGMachine(CFGMachine object) {
				return createCFGMachineAdapter();
			}
			public Object caseCFGPsudoEnumeration(CFGPsudoEnumeration object) {
				return createCFGPsudoEnumerationAdapter();
			}
			public Object caseHyadesPasswordCategory(HyadesPasswordCategory object) {
				return createHyadesPasswordCategoryAdapter();
			}
			public Object caseHyadesClasspathCategory(HyadesClasspathCategory object) {
				return createHyadesClasspathCategoryAdapter();
			}
			public Object caseHyadesRootDirectroyCategory(HyadesRootDirectroyCategory object) {
				return createHyadesRootDirectroyCategoryAdapter();
			}
			public Object caseCMNNamedElement(CMNNamedElement object) {
				return createCMNNamedElementAdapter();
			}
			public Object caseBVRProperty(BVRProperty object) {
				return createBVRPropertyAdapter();
			}
			public Object caseCMNNodeInstance(CMNNodeInstance object) {
				return createCMNNodeInstanceAdapter();
			}
			public Object caseCMNNodeType(CMNNodeType object) {
				return createCMNNodeTypeAdapter();
			}
			public Object defaultCase(EObject object) {
				return createEObjectAdapter();
			}
		};

	/**
	 * Creates an adapter for the <code>target</code>.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target the object to adapt.
	 * @return the adapter for the <code>target</code>.
	 * @generated
	 */
	public Adapter createAdapter(Notifier target) {
		return (Adapter)modelSwitch.doSwitch((EObject)target);
	}


	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGLocation <em>CFG Location</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGLocation
	 * @generated
	 */
	public Adapter createCFGLocationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGClass <em>CFG Class</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGClass
	 * @generated
	 */
	public Adapter createCFGClassAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGOperation <em>CFG Operation</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGOperation
	 * @generated
	 */
	public Adapter createCFGOperationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGArtifact <em>CFG Artifact</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifact
	 * @generated
	 */
	public Adapter createCFGArtifactAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGInstance <em>CFG Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGInstance
	 * @generated
	 */
	public Adapter createCFGInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGComparableProperty <em>CFG Comparable Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGComparableProperty
	 * @generated
	 */
	public Adapter createCFGComparablePropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGPropertyGroup <em>CFG Property Group</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPropertyGroup
	 * @generated
	 */
	public Adapter createCFGPropertyGroupAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGCategory <em>CFG Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGCategory
	 * @generated
	 */
	public Adapter createCFGCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration <em>Hyades Operating System Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemEnumeration
	 * @generated
	 */
	public Adapter createHyadesOperatingSystemEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemCategory <em>Hyades Operating System Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesOperatingSystemCategory
	 * @generated
	 */
	public Adapter createHyadesOperatingSystemCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeCategory <em>Hyades Processor Type Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeCategory
	 * @generated
	 */
	public Adapter createHyadesProcessorTypeCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesMemorySizeCategory <em>Hyades Memory Size Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesMemorySizeCategory
	 * @generated
	 */
	public Adapter createHyadesMemorySizeCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorSpeedCategory <em>Hyades Processor Speed Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorSpeedCategory
	 * @generated
	 */
	public Adapter createHyadesProcessorSpeedCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration <em>Hyades Processor Type Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorTypeEnumeration
	 * @generated
	 */
	public Adapter createHyadesProcessorTypeEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserTypeCategory <em>Hyades Browser Type Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserTypeCategory
	 * @generated
	 */
	public Adapter createHyadesBrowserTypeCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserVersionCategory <em>Hyades Browser Version Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserVersionCategory
	 * @generated
	 */
	public Adapter createHyadesBrowserVersionCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration <em>Hyades Browser Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesBrowserEnumeration
	 * @generated
	 */
	public Adapter createHyadesBrowserEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesProcessorNumberCategory <em>Hyades Processor Number Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesProcessorNumberCategory
	 * @generated
	 */
	public Adapter createHyadesProcessorNumberCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthCategory <em>Hyades Display Color Depth Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthCategory
	 * @generated
	 */
	public Adapter createHyadesDisplayColorDepthCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration <em>Hyades Display Color Depth Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayColorDepthEnumeration
	 * @generated
	 */
	public Adapter createHyadesDisplayColorDepthEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightCategory <em>Hyades Display Height Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightCategory
	 * @generated
	 */
	public Adapter createHyadesDisplayHeightCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthCategory <em>Hyades Display Width Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthCategory
	 * @generated
	 */
	public Adapter createHyadesDisplayWidthCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration <em>Hyades Display Height Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayHeightEnumeration
	 * @generated
	 */
	public Adapter createHyadesDisplayHeightEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration <em>Hyades Display Width Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayWidthEnumeration
	 * @generated
	 */
	public Adapter createHyadesDisplayWidthEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDisplayNumberCategory <em>Hyades Display Number Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDisplayNumberCategory
	 * @generated
	 */
	public Adapter createHyadesDisplayNumberCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseCategory <em>Hyades Database Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseCategory
	 * @generated
	 */
	public Adapter createHyadesDatabaseCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseVersionCategory <em>Hyades Database Version Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseVersionCategory
	 * @generated
	 */
	public Adapter createHyadesDatabaseVersionCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration <em>Hyades Database Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesDatabaseEnumeration
	 * @generated
	 */
	public Adapter createHyadesDatabaseEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGMachineInstance <em>CFG Machine Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGMachineInstance
	 * @generated
	 */
	public Adapter createCFGMachineInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGMachineConstraint <em>CFG Machine Constraint</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGMachineConstraint
	 * @generated
	 */
	public Adapter createCFGMachineConstraintAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGConfigurableObject <em>CFG Configurable Object</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGConfigurableObject
	 * @generated
	 */
	public Adapter createCFGConfigurableObjectAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesHostnameCategory <em>Hyades Hostname Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesHostnameCategory
	 * @generated
	 */
	public Adapter createHyadesHostnameCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesWindowsDomainCategory <em>Hyades Windows Domain Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesWindowsDomainCategory
	 * @generated
	 */
	public Adapter createHyadesWindowsDomainCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesUsernameCategory <em>Hyades Username Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesUsernameCategory
	 * @generated
	 */
	public Adapter createHyadesUsernameCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackCategory <em>Hyades Service Pack Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackCategory
	 * @generated
	 */
	public Adapter createHyadesServicePackCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesMajorVersionCategory <em>Hyades Major Version Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesMajorVersionCategory
	 * @generated
	 */
	public Adapter createHyadesMajorVersionCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesMinorVersionCategory <em>Hyades Minor Version Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesMinorVersionCategory
	 * @generated
	 */
	public Adapter createHyadesMinorVersionCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration <em>Hyades Service Pack Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesServicePackEnumeration
	 * @generated
	 */
	public Adapter createHyadesServicePackEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair <em>CFG Artifact Location Pair</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGArtifactLocationPair
	 * @generated
	 */
	public Adapter createCFGArtifactLocationPairAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGMachine <em>CFG Machine</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGMachine
	 * @generated
	 */
	public Adapter createCFGMachineAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration <em>CFG Psudo Enumeration</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.CFGPsudoEnumeration
	 * @generated
	 */
	public Adapter createCFGPsudoEnumerationAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesPasswordCategory <em>Hyades Password Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesPasswordCategory
	 * @generated
	 */
	public Adapter createHyadesPasswordCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesClasspathCategory <em>Hyades Classpath Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesClasspathCategory
	 * @generated
	 */
	public Adapter createHyadesClasspathCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.configuration.HyadesRootDirectroyCategory <em>Hyades Root Directroy Category</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.configuration.HyadesRootDirectroyCategory
	 * @generated
	 */
	public Adapter createHyadesRootDirectroyCategoryAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.common.CMNNamedElement <em>CMN Named Element</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.common.CMNNamedElement
	 * @generated
	 */
	public Adapter createCMNNamedElementAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.interactions.BVRProperty <em>BVR Property</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.interactions.BVRProperty
	 * @generated
	 */
	public Adapter createBVRPropertyAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.common.CMNNodeInstance <em>CMN Node Instance</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.common.CMNNodeInstance
	 * @generated
	 */
	public Adapter createCMNNodeInstanceAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for an object of class '{@link org.eclipse.hyades.models.common.common.CMNNodeType <em>CMN Node Type</em>}'.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null so that we can easily ignore cases;
	 * it's useful to ignore a case when inheritance will catch all the cases anyway.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @see org.eclipse.hyades.models.common.common.CMNNodeType
	 * @generated
	 */
	public Adapter createCMNNodeTypeAdapter() {
		return null;
	}

	/**
	 * Creates a new adapter for the default case.
	 * <!-- begin-user-doc -->
	 * This default implementation returns null.
	 * <!-- end-user-doc -->
	 * @return the new adapter.
	 * @generated
	 */
	public Adapter createEObjectAdapter() {
		return null;
	}

} //Common_ConfigurationAdapterFactory
