/**********************************************************************
 * Copyright (c) 2005 IBM Corporation and others.
 * All rights reserved.   This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * $Id: DBVisitorFactory.java,v 1.4 2005/02/16 22:21:28 qiyanli Exp $
 *
 * Contributors:
 * IBM - Initial API and implementation
 **********************************************************************/
package org.eclipse.hyades.resources.database.internal;

import org.eclipse.hyades.resources.database.internal.impl.DBVisitorFactoryImpl;
/**
 * This interface lets you create a DBVisitor.
 */
public interface DBVisitorFactory {
	/**
	 * Create a DBVisitor that uses the given database object. The PagingLists
	 * it returns have the given paging size.
	 * 
	 * @param database
	 *            The database object used to get objects from the database
	 * @param pagingSize
	 *            The paging size for the PagingLists returned by the DBVisitor
	 * @return A new DBVisitor object
	 */
	DBVisitor create(Database database, int pagingSize);

	/**
	 * A DBVisitorFactory for you to use.
	 */
	DBVisitorFactory INSTANCE = new DBVisitorFactoryImpl();
} // DBVisitorFactory
